# How to run in development env ?

```
docker stack deploy --compose-file=docker-compose.yml plugin-wp
```

```
docker stack rm plugin-wp
```

# How to allow the cookies to be secure and samesite ?

https://web.dev/samesite-cookie-recipes/
https://blog.heroku.com/chrome-changes-samesite-cookie

```
ini_set('session.cookie_samesite', 'None');
ini_set('session.cookie_secure', true);
```
Add this upward the session init or to the index or in the wp-config to allow your cookies to be secure and to be able to pass even with a redirect.
Please note that you site need to be in HTTPS.

# How to pass your Wordpress in HTTPS ? 

In your wp-config add this just upward the sql configuration : 

```
define('FORCE_SSL_ADMIN', true);
$_SERVER['HTTPS']='on';
```

and define your new HTTPS URL, just below the debug configuration by adding : 

 ```
define('WP_HOME','https://example.net');
define('WP_SITEURL','https://example.net');
 ```

