<?php
/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       http://www.centralpay.eu/
 * @since      1.0.0
 *
 * @package    cpay
 * @subpackage cpay/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    cpay
 * @subpackage cpay/includes
 * @author     CentralPay
 */
class Cpay
{
    const ENCRIPTION_IV = "1234567891011121";
    public function __construct() {

    }

    public static function encrypteData($order) {
        if (!empty($order) && is_int($order)) {
            $ciphering = "AES-128-CTR";
            $iv_length = openssl_cipher_iv_length($ciphering);
            $options = 0;
            $salt = get_option('woocommerce_cpay_settings')['salt'];
            $encryption_key = "cpay" . $salt;
            $encryption_iv = Cpay::ENCRIPTION_IV;
            return openssl_encrypt($order, $ciphering,
                $encryption_key, $options, $encryption_iv);
        }
        newLog("[ERROR]class-cpay.php l.".__LINE__." ENCRYPT DATA BAD VALUE, {asked(int) order : sent(".gettype($order).") ".$order."}");
        return "";
    }

    public static function decrypteData($encryption) {
        if (!empty($encryption)) {
            $ciphering = "AES-128-CTR";
            $iv_length = openssl_cipher_iv_length($ciphering);
            $options = 0;
            $salt = get_option('woocommerce_cpay_settings')['salt'];
            $encryption_key = "cpay" . $salt;
            $encryption_iv = Cpay::ENCRIPTION_IV;
            return openssl_decrypt($encryption, $ciphering,
                $encryption_key, $options, $encryption_iv);
        }
        newLog("[ERROR]class-cpay.php l.".__LINE__." DECRYPT DATA EMPTY ENCRYPTION, {asked encryption : sent(".gettype($encryption).") ".$encryption."}");
        return "";
    }

    public static function getUrlSmartForm($order_id, $requete) {
        if ((!empty($requete) && !empty($requete['reponse'])) && (!empty($order_id) && is_int($order_id))) {
            if (!empty($requete['reponse']->breakdowns) && !empty($requete['reponse']->breakdowns[0]->endpoint)) {
                $response = $requete['reponse']->breakdowns[0]->endpoint;
                $paymentRequestId = $requete['reponse']->paymentRequestId;
                $orderIdEncrypte = Cpay::encrypteData($order_id);
                if (!empty($orderIdEncrypte)) {
                    $urlredirect = $response.'?urlRedirect='.get_site_url().'?wc-api=cpay_paid%26idOrder='.$orderIdEncrypte.'%26paymentRequestId='.$paymentRequestId.'&delay=3';
                    return $urlredirect;
                }
                newLog("[ERROR]class-cpay.php l.".__LINE__." GET URL SMART FORM EMPTY ORDER ID ENCRYPT, {asked(string) orderIdEncrypte : sent(".gettype($orderIdEncrypte).") ".$orderIdEncrypte."}");
                return "";
            }
            newLog("[ERROR]class-cpay.php l.".__LINE__." GET URL SMART FORM BAD VALUE BREAKDOWS/ENDPOINT, {{asked(array) requete['reponse']->breakdown : sent(".gettype($requete['reponse']->breakdowns).")".json_encode($requete['reponse']->breakdowns)."},{asked(string) endpoint : sent(".gettype($requete['reponse']->breakdowns[0]->endpoint).") ".$requete['reponse']->breakdowns[0]->endpoint."}");
            return "";

        }
        newLog("[ERROR]class-cpay.php l.".__LINE__." GET URL SMART FORM BAD VALUE, {{asked requete : sent ".json_encode($requete)."},{asked requete['reponse'] : sent ".$requete->reponse."},{asked(int) order_id : sent(".gettype($order_id).") ".$order_id."}");
        return "";
    }
}
